#ifndef MAIN_H
#define MAIN_H

#include "../linux_port/graph.h"

class System;

struct RandSysParams
{
	//bounds on values
	int max_procs;
	int min_procs; 
	float max_bound; 
	float min_bound;				 
	int max_comps;
	int min_comps;
	float max_util;
	float min_util;
	float max_period;
	float min_period;
	int max_input_comps;
	int min_input_comps;
	int max_output_comps;
	int min_output_comps;
	int max_output_degree;
	int min_output_degree;
	int max_msg_size;
	int min_msg_size;

	//controls
	bool use_GME_hw;
	bool append_sys;
};

//generate a random system from the parameters given in param and put the results in
//global variables rand_sys and rand_grp.  Assumes that all variables in param have been
//checked for errors.
void GenerateRandSys(RandSysParams param);

//Generate a description of the system given in p_sys and add this description to it
void GenerateDescription(System* p_sys);

//Generate a description of the graph given in p_graph and add this description to it
void GenerateDescription(Graph* p_graph);

//Store the descriptions of the given system and graph into a file
void StoreSystem(System& system, Graph& graph);

#endif