#if !defined(AFX_WARNING_H__BAC8A0E9_4E3F_4AA7_9DA2_D3C045FA6788__INCLUDED_)
#define AFX_WARNING_H__BAC8A0E9_4E3F_4AA7_9DA2_D3C045FA6788__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// warning.h : header file
//

#include "..\resource.h"
#include "StdAfx.h"

#include <fstream>

bool WarningBox(CString);			//displays a warning and asks the user if they
									//would like to display this type of message in
									//the future - returns true if warnings should
									//not be displayed

/* Functions and a struct for the users preferences*/
void Load_User_Preferences();		//load the user preferences from a file

int Get_True_False(std::ifstream& in);	//read in a true or false value - returns 1
									//for true, 0 for false, and -1 for fail

void Read_Error(CString word);		//error when reading the file set preferences to
									//defaults and display message box saying so

void Save_User_Preferences();		//save the user's preferences to a file

void Set_Default_Preferences();		//set the values to there defaults (all true)

//struct to hold the user's preferences
struct user_preferences
{
	bool no_cpu_warnings_on;			//not all sw blocks are mapped to a cpu
	bool different_cpus_warnings_on;	//a subsystem and its sw block have different cpus
	bool zero_period_warnings_on;		//a subsystem has a period of 0
	bool undefined_mem_vars_warnings_on;//one or more of the memory variables are undefined
};
/***************************************************/

/////////////////////////////////////////////////////////////////////////////
// warning dialog

class warning : public CDialog
{
// Construction
public:
	warning(CWnd* pParent = NULL);   // standard constructor

	bool display_message(CString msg);
// Dialog Data
	//{{AFX_DATA(warning)
	enum { IDD = IDD_DIALOG2 };
	CEdit	m_edit;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(warning)
	public:
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	bool checked;
	CString msg_str;

	// Generated message map functions
	//{{AFX_MSG(warning)
	afx_msg void OnCheck();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WARNING_H__BAC8A0E9_4E3F_4AA7_9DA2_D3C045FA6788__INCLUDED_)
