#ifndef SCHEDULE_H_0
#define SCHEDULE_H_0

#include "system.h"
#include "table.h"
#include "task_allocation.h"

extern bool Schedule_Task (TaskType*, Processor *,IBP_Policy&);
extern void Schedule_Task (Processor *);
extern void Schedule_CAN_Messages (System&);
extern void order_tasks_dependency (list<TaskType*>&, list<TaskType*>&);
extern float Get_Task_Utilization (Processor *);
extern float Get_Scheduling_Utilization (Processor *);
extern float Get_Context_Switch_Utilization (Processor *);
extern float Get_Timer_Utilization (Processor *);
extern float Get_Network_Utilization (System&);
extern void Split_Interference(Processor *,Table<TaskType*,float>&);
extern void set_rma_priority (Processor *);
extern void set_rma_priority (Graph&);
extern void set_rma_priority (System&);
extern void Restore_MP_SP (Processor *);

#endif

