#ifndef TASK_ALLOCATION_H_0
#define TASK_ALLOCATION_H_0

#include "processor_network.h"
#include "system.h"

#undef OP_FAIL
#undef OP_SUCCESS

#define OP_FAIL         0
#define OP_SUCCESS      1

enum scheduling_policy
{
    ADVANCED_RMA,
    PRIORITY_POLICY,
    EDF_POLICY
};

enum mapping_policy
{
	NONE,
    SUBSYSTEM_MAPPING,
    PERIOD_MAPPING,
    PRIORITY_MAPPING,
	FIRSTFIT_MAPPING,
	LOAD_BALANCE_MAPPING,
	COMM_MIN_MAPPING,
	MULTIPLE_CONSTRAINTS_MAPPING,
	OPTIMAL_MAPPING
};

struct IBP_Policy
{
	IBP_Policy() : fo_mp(NONE), so_mp(NONE){}
    scheduling_policy sp;
    mapping_policy fo_mp;
	mapping_policy so_mp;
	bool debug;
};

class allocation_stats
{
    private:
        int counts;
    public:
        allocation_stats(){counts=0;}
        inline void Incr(){counts++;}
        inline int Get_Count(){return counts;}
        inline void Reset () {counts=0;}
};
        
#endif

