#ifndef TOOLS_H
#define TOOLS_H

#include <list>
#include "../StdAfx.h"

enum ErrorType {NOT_A_NUMBER, TOO_BIG_DISPLAY, TOO_SMALL_DISPLAY, TOO_BIG_NO_DISPLAY, 
                TOO_SMALL_NO_DISPLAY, SWAP_VALUES};

template<class T = CString>
class Error
{
public:
	Error(CString in_msg = "") : msg(in_msg) {}
	CString msg;
	std::list<T> templated_list1;
	std::list<T> templated_list2;
	ErrorType type;
};

inline double mod_double(double x, double y)
{
	return x - y*int(x/y);
}

template<class T>
inline bool OnList(T element, std::list<T>& T_list)
{
	for(std::list<T>::iterator it = T_list.begin(); it != T_list.end(); ++it)
		if(*it == element) return true;
	return false;
}

template<class T = double>
inline bool TestAndAssignMax(T& current_max, T test_val)
{
	if(test_val > current_max)
		{current_max = test_val; return true;}
	return false;
}

template<class T>
inline void SafeDelete(T* pointer)
{
	if(pointer)
	{
		delete pointer;
		pointer = NULL;
	}
}

inline double abs_double(double d)
{
	if(d < 0)
		return -d;
	return d;
}

BOOL DoMyPromptFileName(CString& fileName, CString title, CString strFilter,int bOpenFileDialog);

#endif