#ifndef TREENODE_H
#define TREENODE_H

#include "processor_network.h"

class TreeNode;

class TreeNode
{
    private:
        TaskType *ptask;
        Processor *pproc;
        TreeNode *parent;
        list<TreeNode *> children;
        float value;
        bool issol;
    public:
        TreeNode()
        {
            ptask=NULL;pproc=NULL;parent=NULL;value=NIL;children.clear();
            issol=false;
        };
        inline void Add_Child(TreeNode *tn){children.push_front(tn);};
        void Delete_Child(TreeNode *tn)
        {
            list<TreeNode*>::iterator ic=find(children.begin(),children.end(),tn);
            if(ic!=children.end())
                children.erase(ic);
        }
        inline void Clear_Children(){children.clear();};
        inline float Get_Value(){return value;};
        inline void Set_Value(float f){value=f;};
        inline void Set_Task (TaskType *pt){ptask=pt;};
        inline void Set_Processor (Processor *pr){pproc=pr;};
        inline void Set_Parent(TreeNode *ptn){parent=ptn;};
        inline Processor *Get_Processor(){return pproc;};
        inline TaskType *Get_Task(){return ptask;};
        inline list<TreeNode *>::iterator Begin_Children(){return children.begin();};
        inline list<TreeNode *>::iterator End_Children(){return children.end();};
        inline int Get_Number_Of_Children(){return children.size();};
        inline TreeNode* Get_Parent(){return parent;};
        inline void Set_Solution(bool b){issol=b;};
        inline bool Get_Solution(){return issol;};
        TreeNode * Get_Best_Child();
};
    
#endif
#ifdef DMALLOC
#include <dmalloc.h>
#endif
