#include "..\stdafx.h"
#include "windows.h"
#include "system.h"

void System::Order_Procs_By_CAN_ID ()
{
    list<Processor*>::iterator ipl;
    list<Processor*>::iterator iproc_list;
    list<Processor*> proc_list;
    bool inserted;
    
    for(ipl=processor_list.begin();ipl!=processor_list.end();ipl++)
    {
        Processor *pproc=*ipl;
        inserted=false;
        
        for(iproc_list=proc_list.begin();iproc_list!=proc_list.end();iproc_list++)
        {
            Processor *pproc2=*iproc_list;
            
            if(pproc->Property()->Get_CAN_ID()>pproc2->Property()->Get_CAN_ID())
            {
                proc_list.insert(iproc_list,pproc);
                inserted=true;
                break;
            }
        }
        if(!inserted) proc_list.push_back(pproc);
    }
}

OS* System::Get_OS_By_Name(CString& n)
{
    list<OS *>::iterator oi;

    for(oi=oses.begin();oi!=oses.end();oi++)
    {
        OS* pos=*oi;

        if(pos->Property()->Get_Name()==n) return pos;
    }
    return NULL;
}

Processor* System::Get_Proc_By_Name(CString& n)
{
	list<Processor *>::iterator pi;

	for(pi=processor_list.begin();pi!=processor_list.end();pi++)
	{
		Processor *pproc=*pi;

		if(pproc->Property()->Get_Name()==n) return pproc;
	}
	return NULL;
}

Network* System::Get_Network_By_Name(CString& n)
{
    list<Network *>::iterator ni;

    for(ni=network_list.begin();ni!=network_list.end();ni++)
    {
        Network *pnet=*ni;

        if(pnet->Property()->Get_Name()==n) return pnet;
    }
    return NULL;
}

void System::Clean ()
{
    list<Processor *>::iterator pi;
    list<Network *>::iterator ni;
    list<OS *>::iterator oi;

    for(pi=processor_list.begin();pi!=processor_list.end();pi++)
    {
        Processor *pproc=*pi;

        delete pproc;
    }

	processor_list.clear();

    for(ni=network_list.begin();ni!=network_list.end();ni++)
    {
        Network *pnet=*ni;

        delete pnet;
    }

	network_list.clear();

    for(oi=oses.begin();oi!=oses.end();oi++)
    {
        OS* pos=*oi;

        delete pos;
    }

	oses.clear();

    return;
}

    
