#ifndef TASK_ALLOCATION_H_0
#define TASK_ALLOCATION_H_0

#include "processor_network.h"
#include "system.h"

#undef OP_FAIL
#undef OP_SUCCESS

#define OP_FAIL         0
#define OP_SUCCESS      1

enum scheduling_policy
{
    ADVANCED_RMA,
    PRIORITY_POLICY,
    EDF_POLICY
};

enum mapping_policy
{
    SUBSYSTEM_MAPPING,
    PERIOD_MAPPING,
    PRIORITY_MAPPING,
	FIRSTFIT_MAPPING,
	LOAD_BALANCE_MAPPING
};

typedef struct
{
    scheduling_policy sp;
    mapping_policy mp;
	bool debug;
} IBP_Policy;

class allocation_stats
{
    private:
        int counts;
    public:
        allocation_stats(){counts=0;}
        inline void Incr(){counts++;}
        inline int Get_Count(){return counts;}
        inline void Reset () {counts=0;}
};
        
#endif

